/**************
*
*Includes
*
*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/**************
*
*prototypes
*
*/

void    prot_or_nuc();
void    getstr(char *instr, char *outstr);
void    qse( void );
int     number( void );
void    modelDNA( void );
void    modelPROT( void );
double  getreal(char *instr,double minx,double maxx,double def);
int     getint(char *instr,int minx,int maxx, int def);
void    bootsplit(void);
void    format(void);

/**************
*
*global variables
*
*/

int     code = 1;
int     a = 1;
int     treenum = 0;
int     num = 50;
float   AB = 4.0;
float   YR = 1.0;

char    modeldna[10] =  {'t', '\0' };
char    modelprot[10] = {'j', '\0' };
char    search[3] =     {'q', '\0' };
char    fmt[2] =        {'I', '\0' };
char    bootfilnam[36];

/**************
*
*defines
*
*/

#define MAXLINE 10000
#define TRUE 1
#define FALSE 0

/**************
*
*main function
*
*/

main()
{
printf("**************************************************************\n");
printf("**************************************************************\n");
printf("**      PHYCON: A tool for bootstrapping using PHYLIP       **\n");
printf("**                         and MOLPHY                       **\n");
printf("**                                                          **\n");
printf("**                     by James McInerney                   **\n");
printf("**                email: james.o.mcinerney@may.ie           **\n");
printf("**************************************************************\n");
printf("**************************************************************");

prot_or_nuc();
qse();
format();
num = number();
printf("\n\nRetaining %d top-ranking trees\n\n", num);

if(code == 1) modelPROT();
if(code == 2) modelDNA();

 bootsplit();

printf("\nExiting\n\n");
return 1;
}

/**************
*
*Get the name of the input file
*Write out a short shell script
*make it executable
*execute it
*delete it
*
*/

void bootsplit(void)
{
int i = 0, j = 0, lines=100, onefile, boots=100;
char filnam[36], scriptfile[36] = "scriptfile ", dest1[50] = "chmod a+x scriptfile",  scriptfile2[36] = "scriptfile2";
	//-pac-
char rm2[20] = "rm tmp2", dest2[20] = "rm scriptfile", dest3[50] = "chmod a+x scriptfile2", dest4[20] = "rm temporaryfile", dest5[25] = "chmod a+x temporaryfile", dest6[15] = "temporaryfile";
FILE *outfp, *outfp2, *outfp3, *outfp4, *filname, *tmp1, *tmp2;

if(code == 2 && modeldna[0] == 't' && a == 1) sprintf(modeldna, "%s %1.2f", modeldna, AB);
if(code == 2 && modeldna[0] == 't' && a == 2) sprintf(modeldna, "%s %1.2f,%1.2f", modeldna, AB, YR);

  /*    getstr("\n\nName of the script file", scriptfile); */

if((outfp = fopen("scriptfile","w")) == NULL)
{      printf("Cannot open scriptfile");
      return;
}
      getstr("\n\nName of the Seqboot outfile", filnam);

if((filname = fopen (filnam,"r")) == NULL)
{      printf("cannot open %s", filnam);
      return;
}

if((tmp1 = fopen ("temporaryfile","w")) == NULL)
{      printf("cannot open temporaryfile\n");
      return;
}
fprintf(tmp1, "wc %s >tmp2\n", filnam);
fclose(tmp1);
system(dest5);
system(dest6);
system(dest4);

if((tmp2 = fopen ("tmp2","r")) == NULL)
{      printf("cannot open tmp2\n");
      return;
}
fscanf(tmp2, "%d", &lines);
system(rm2);
printf("File contains %d lines\n", lines);

          bootfilnam == filnam;

     /* lines = getint("\n\nHow many lines in the file", 1, 10000000,lines); */
      boots = getint("\n\nHow many bootstrap replicates", 1, 100000, boots);

         onefile = lines/boots;

       for(i=onefile, j=0; i <= lines; i+=onefile, j++){

  fprintf(outfp, "head -%d %s | tail -%d  >%s.%d\n", i, filnam, onefile ,filnam, j+1 );

  if(code==1){
     /*  for( j=0; j < boots;  j++){ */

  fprintf(outfp, "protml -%s -%s -%s -n %d %s.%d >out%s%d.%d\n",fmt, modelprot, search, num, filnam, j+1, search, num, j+1 );
  fprintf(outfp, "protml -%s -%s -u -b %s.%d out%s%d.%d >ML.%s%d.%d\n",fmt, modelprot, filnam, j+1, search, num, j+1, search, num, j+1 );
  fprintf(outfp, "rm %s.%d\n", filnam, j+1);
   /*    } */
      }
      else {
     /*  for( j=0; j < boots;  j++){ */

  fprintf(outfp, "nucml -%s -%s -%s -n %d %s.%d >out%s%d.%d\n", fmt, modeldna, search, num, filnam, j+1, search, num,  j+1 );
  fprintf(outfp, "nucml -%s -%s -u -b %s.%d out%s%d.%d >ML.%s%d.%d\n", fmt, modeldna, filnam, j+1, search, num, j+1, search, num, j+1 );

fprintf(outfp, "rm %s.%d\n", filnam, j+1);
    /*   }  */
}
}
       fclose(outfp);
       fclose(filname);
       system(dest1);
       system(scriptfile);

if((outfp4 = fopen("scriptfile4","w")) == NULL)
{      printf("Cannot open scriptfile4");
      return;
}


       for( j = 0; j < boots; j++){
if((outfp2 = fopen("scriptfile2","w")) == NULL){
      printf("Cannot open scriptfile2");
      return;
}
       fprintf(outfp2, "grep best ML.%s%d.%d > scriptfile3\n", search, num,
j+1);
       fprintf(outfp2, "rm ML.%s%d.%d\n", search, num, j+1);

      fclose(outfp2);

       system(dest3);
       system(scriptfile2);

          if((outfp3 = fopen("scriptfile3","r")) == NULL){
               printf("Cannot open scriptfile3");
               return;
}
        fscanf(outfp3, "%d" , &treenum);

   fclose(outfp3);

system("touch besttrees");
   if(treenum >= 1){
           fprintf(outfp4, "head -%d out%s%d.%d | tail -1 >>besttrees\n",
treenum+1, search, num, j+1);
           fprintf(outfp4, "rm out%s%d.%d\n", search, num, j+1);
         treenum = 0;
                }
else {
      fprintf(outfp4, "head -2 out%s%d.%d | tail -1 >>besttrees\n", search,
num, j+1);
     }
}
       fclose(outfp4);
       system("chmod a+x scriptfile4");
       system("scriptfile4");

       return;
     }

/**************
*
*Is the dataset protein or nucleotide?
*
*/

void prot_or_nuc()
{
char lin1[2];
for(;;){
        printf("\n\n\n\nWhich MOLPHY program do you wish to use?\n\n");
        printf("\n\n1.          protml");
                if(code == 1) printf("  ON\n");
                else printf("  OFF\n");
        printf("2.          nucml");
                if(code == 2) printf("   ON\n\n\n");
                else printf("   OFF\n\n\n");
        printf("Press [Return] to continue\n\n\n");
                        getstr("enter your choice", lin1);
                switch(toupper(*lin1)) {
              case '1' : code = 1;
                         continue;
              case '2' : code = 2;
                         continue;
              default  : break;
               }
               break;
            }
          return;
        }

void format()
{
char lin1[2];
for(;;){
        printf("\n\n\n\n\nIn which format is your bootstrap pseudoreplicate datafile?\n\n");
        printf("\n\n1.          Interleaved");
                if(fmt[0] == 'I') printf("  ON\n");
                else printf("  OFF\n");
        printf("2.          Sequential");
                if(fmt[0] == 'S') printf("   ON\n\n\n");
                else printf("   OFF\n\n\n");
        printf("Press [Return] to continue\n\n\n");
                        getstr("enter your choice", lin1);
                switch(toupper(*lin1)) {
              case '1' : fmt[0] = 'I';
                         continue;
              case '2' : fmt[0] = 'S';
                         continue;
              default  : break;
               }
               break;
            }
          return;
        }

/**************
*
*What kind of search?
*
*/

void qse( void )
{
char lin1[2];
for(;;){
        printf("\n\n\n\nWhich kind of search do you wish to carry out on your datasets?\n\n");
        printf("\n\n1.          star search");
               if(search[0] == 's') printf("         ON\n");
                else printf("         OFF\n");
            printf("2.          quick search");
               if(search[0] == 'q') printf("        ON\n");
                else printf("        OFF\n");
        printf("3.          exhaustive search");
               if(search[0] == 'e') printf("   ON (disabled)\n\n\n");
                else printf("   OFF (disabled)\n\n\n");

        printf("Press [Return] to continue\n\n\n");
                        getstr("enter your choice", lin1);
                switch(toupper(*lin1)) {
              case '1' : search[0] = 's';
                         continue;
              case '2' : search[0] = 'q';
                         continue;
              case '3' : search[0] = 'q';
                         getstr("Disabled - hit <return> to continue", lin1);
                         continue;
              default  : break;
               }
               break;
            }
          return;
        }

/**************
*
*Retain how many trees?
*
*/

int number( void )
{
int lin1 = 50;
printf("\n\n\n\n\n-n num retained top ranking trees with Approx.likelihood\n");
        printf("\n\n\tnum = %d\n\n\n", 50);
        printf("Press [Return] to continue\n\n");
    lin1=getint("Enter your choice",1,1000, 50);
          return lin1;
        }

/**************
*
*Which DNA model to use?
*
*/

void modelDNA( void )
{
char lin1[2];
for(;;){
             printf("Which DNA substitution model do you wish to use?\n\n");
             printf("\n\n1.          HKY");
           if(modeldna[0] == 't' && a == 1) {
                                 printf("                  ON\n");
           printf("\tA.\tAlpha/Beta ratio %1.2f\n", AB);
                                  } 
                            else printf("                  OFF\n");
                printf("2.          TN93");
           if(modeldna[0] == 't' && a == 2) {
                                 printf("                 ON\n");
           printf("\tA.\tAlpha/Beta ratio    %1.2f\n", AB);
           printf("\tB.\tAlphaY/AlphaR ratio %1.2f\n", YR);
             }
           else                  printf("                 OFF\n");
        printf("3.          proportional");
           if(modeldna[0] == 'p' && modeldna[1] == '\0' )printf("         ON\n");
                            else printf("         OFF\n");
             printf("4.          poisson");
                if(modeldna[0] == 'p'  && modeldna[1] == 'f') printf("              ON\n\n\n");
                                                         else printf("              OFF\n\n\n");

             printf("Press [Return] to continue\n\n\n");
                        getstr("enter your choice", lin1);
                switch(toupper(*lin1)) {
              case '1' : modeldna[0] = 't'; a=1;
                         continue;
              case '2' : modeldna[0] = 't'; a=2;
                         continue;
              case '3' : modeldna[0] = 'p'; modeldna[1] = '\0';
                         continue;
              case '4' : modeldna[0] = 'p'; modeldna[1] = 'f'; modeldna[2] = '\0';
                         continue;
              case 'A' : printf("AB ratio currently %f\n", AB);
                         AB=(float)getreal("Enter number",(double)0.0,(double)100.0,(double)AB);
                         continue;
              case 'B' : printf("YR ratio currently %f\n", YR);
                         YR=(float)getreal("Enter number",(double)0.0,(double)100.0,(double)YR);
                         continue;
              default  : break;
               }
               break;
            }
          return;
        }


/**************
*
*Which protein model to use?
*
*/

void modelPROT( void )
{
char lin1[2];
for(;;){
printf("Which Protein model do you wish to use?\n\n");
            printf("\n\n1.          JTT");
  if(modelprot[0] == 'j' && modelprot[1] == '\0') printf("              ON\n");
                                             else printf("              OFF\n");
                printf("2.          JTTF");
  if(modelprot[0] == 'j' && modelprot[1] == 'f')  printf("             ON\n");
                                             else printf("             OFF\n");
printf("3.          Dayhoff");
  if(modelprot[0] == 'd' && modelprot[1] == '\0') printf("          ON\n");
                                             else printf("          OFF\n");
printf("4.          Dayhoff-F");
   if(modelprot[0] == 'd' && modelprot[1] == 'f') printf("        ON\n");
                                             else printf("        OFF\n");
printf("5.          poisson");
     if(modelprot[0] == 'p' && modelprot[1] == '\0')printf("          ON\n");
                                               else printf("          OFF\n");
              printf("6.          proportional");
      if(modelprot[0] == 'p' && modelprot[1] == 'f') printf("     ON\n\n\n");
                                                else printf("     OFF\n\n\n");

        printf("Press [Return] to continue\n\n\n");
                        getstr("enter your choice", lin1);
                switch(toupper(*lin1)) {
              case '1' : modelprot[0] = 'j'; modelprot[1] = '\0';
                         continue;
              case '2' : modelprot[0] = 'j'; modelprot[1] = 'f'; modelprot[2] = '\0';
                         continue;
              case '3' : modelprot[0] = 'd'; modelprot[1] = '\0';
                         continue;
              case '4' : modelprot[0] = 'd'; modelprot[1] = 'f'; modelprot[2] = '\0';
                         continue;
              case '5' : modelprot[0] = 'p'; modelprot[1] = '\0';
                         continue;
              case '6' : modelprot[0] = 'p'; modelprot[1] = 'f'; modelprot[2] = '\0';
                         continue;
              default  : break;
               }
               break;
            }
          return;
        }

/**************
*
*Get a floating-point number
*
*/

double getreal(char *instr,double minx,double maxx,double def)
{
        int status;
        float ret;
        char line[MAXLINE];

        while(TRUE) {
                fprintf(stdout,"%s (%.2f-%.2f)   [%.2f]: ",instr,minx,maxx,def);
                gets(line);
                status=sscanf(line,"%f",&ret);
                if(status == EOF) return def;
                if(ret>maxx) {
                        fprintf(stdout,"ERROR: Max. value=%.2f\n\n",maxx);
                        continue;
                }
                if(ret<minx) {
                        fprintf(stdout,"ERROR: Min. value=%.2f\n\n",minx);
                        continue;
                }
                break;
        }
        return (double)ret;
}

/**************
*
*Get an integer
*
*/

int getint(char *instr,int minx,int maxx, int def)
{
        int ret,status;
        char line[MAXLINE];

        while(TRUE) {
                fprintf(stdout,"%s (%d..%d)    [%d]: ",
                instr,(int)minx,(int)maxx,(int)def);
                gets(line);
                status=sscanf(line,"%d",&ret);
                if(status == EOF) return def;
                if(ret>maxx) {
                        fprintf(stdout,"ERROR: Max. value=%d\n\n",(int)maxx);
                        continue;
                }
                if(ret<minx) {
                        fprintf(stdout,"ERROR: Min. value=%d\n\n",(int)minx);
                        continue;
                }
                break;
        }
        return ret;
}

/**************
*
*Get a string
*
*/

void getstr(char *instr, char *outstr)
{
        fprintf(stdout, "%s: ", instr);
        gets(outstr);
}
